Index: tmp/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/conversion/XMLTXMFileRuledConversion.java
===================================================================
--- tmp/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/conversion/XMLTXMFileRuledConversion.java	(revision 3054)
+++ tmp/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/conversion/XMLTXMFileRuledConversion.java	(revision 3055)
@@ -7,13 +7,20 @@
 import java.util.regex.Pattern;
 
 import javax.xml.stream.XMLStreamException;
+import javax.xml.stream.XMLStreamReader;
 
 import org.txm.importer.StaxIdentityParser;
 
 public class XMLTXMFileRuledConversion extends StaxIdentityParser {
 	
-	protected LinkedHashMap<Pattern, String> rules = new LinkedHashMap<Pattern, String>();
+	public boolean debug = false;
 	
+	protected LinkedHashMap<Pattern, String> rules = new LinkedHashMap<>();
+	
+	protected String elementName = null;
+	
+	boolean fixingElement = false; // true when the current element needs to be fixed
+	
 	protected String oldType;
 	
 	protected String newType;
@@ -24,9 +31,20 @@
 	
 	public static final String ABANDON = "abandon";
 	
-	HashSet<String> noMatchValues = new HashSet<String>();
+	HashSet<String> noMatchValues = new HashSet<>();
 	
-	public XMLTXMFileRuledConversion(File infile, LinkedHashMap<Pattern, String> rules, String oldType, String newType, String mode) throws IOException, XMLStreamException {
+	/**
+	 * 
+	 * @param infile the file to read
+	 * @param rules the conversion rules
+	 * @param elementPath if null, the conversion happens
+	 * @param oldType word type or element attribute to read
+	 * @param newType word type or element attribute to write
+	 * @param mode XMLTXMFileRuledConversion.DELETE or XMLTXMFileRuledConversion.COPY or XMLTXMFileRuledConversion.ABANDON
+	 * @throws IOException
+	 * @throws XMLStreamException
+	 */
+	public XMLTXMFileRuledConversion(File infile, LinkedHashMap<Pattern, String> rules, String elementPath, String oldType, String newType, String mode) throws IOException, XMLStreamException {
 		super(infile);
 		this.rules = rules;
 		this.oldType = oldType;
@@ -34,15 +52,21 @@
 		
 		this.mode = mode;
 		
-		if (!this.newType.startsWith("#")) this.newType = "#" + this.newType;
-		if (!this.oldType.startsWith("#")) this.oldType = "#" + this.oldType;
+		if (elementPath != null && elementPath.length() > 0) {
+			this.elementName = elementPath;
+		}
+		
+		if (elementPath == null) { // where fixing txm:words
+			if (!this.newType.startsWith("#")) this.newType = "#" + this.newType;
+			if (!this.oldType.startsWith("#")) this.oldType = "#" + this.oldType;
+		}
 	}
 	
 	boolean inW = false, inAna = false, inForm;
 	
-	LinkedHashMap<String, String> anaValues = new LinkedHashMap<String, String>();
+	LinkedHashMap<String, String> anaValues = new LinkedHashMap<>();
 	
-	LinkedHashMap<String, String> anaResps = new LinkedHashMap<String, String>();
+	LinkedHashMap<String, String> anaResps = new LinkedHashMap<>();
 	
 	String typeName = null;
 	
@@ -52,116 +76,223 @@
 	
 	private Object mode;
 	
+	public static class Converter {
+		
+		public Converter() {
+			
+		}
+		
+		public String getValue(XMLStreamReader parser, String localname, String attribute, String value) {
+			return value;
+		}
+	}
+	
+	private Converter converter = null;
+	
 	@Override
+	protected void writeAttributes() throws XMLStreamException {
+		if (fixingElement) {
+			String newValue = null;
+			for (int i = 0; i < parser.getAttributeCount(); i++) {
+				String att = parser.getAttributeLocalName(i);
+				String value = parser.getAttributeValue(i);
+				if (oldType != null && oldType.equals(att)) {
+					if (converter != null) {
+						if (debug) System.out.println("CALL CONVERTER with attribute $att");
+						newValue = converter.getValue(parser, localname, att, value);
+					}
+					else {
+						newValue = getValueIfMatch(value);
+					}
+				}
+				if (!newType.equals(att)) { // don't write the newType, it will be done at the end
+					writeAttribute(parser.getAttributePrefix(i), att, value);
+				}
+			}
+			
+			if (oldType == null && converter != null) {
+				if (debug) System.out.println("CALL CONVERTER with no attribute set");
+				newValue = converter.getValue(parser, localname, null, null);
+			}
+			
+			if (newValue != null) {
+				if (debug) System.out.println("WRITE NEWTYPE: " + newType + "=" + newValue);
+				writeAttribute(null, newType, newValue);
+			}
+		}
+		else {
+			super.writeAttributes();
+		}
+	}
+	
+	@Override
 	public void processStartElement() throws XMLStreamException, IOException {
-		if (!inW) super.processStartElement(); // don't write W content
 		
-		if (localname.equals("w")) {
-			inW = true;
-			anaValues.clear();
-			anaResps.clear();
+		
+		if (elementName != null) {
+			if (this.localname.equals(elementName)) {
+				fixingElement = true;
+			}
 			
-			// initialize the new type to a empty value in case there is transformation rule
-			anaValues.put(newType, "");
-			anaResps.put(newType, "#txm_recode");
+			super.processStartElement();
+			fixingElement = false;
 		}
-		else if (localname.equals("ana")) {
-			inAna = true;
-			typeName = parser.getAttributeValue(null, "type");
-			respName = parser.getAttributeValue(null, "resp");
-			anaResps.put(typeName, respName);
-			// if (typeName != null) typeName = typeName.substring(1); // remove #
-			typeValue = "";
+		else {
+			
+			if (!inW) super.processStartElement(); // don't write W content
+			
+			if (localname.equals("w")) {
+				inW = true;
+				anaValues.clear();
+				anaResps.clear();
+				
+				// initialize the new type to a empty value in case there is transformation rule
+				anaValues.put(newType, "");
+				anaResps.put(newType, "#txm_recode");
+			}
+			else if (localname.equals("ana")) {
+				inAna = true;
+				typeName = parser.getAttributeValue(null, "type");
+				respName = parser.getAttributeValue(null, "resp");
+				anaResps.put(typeName, respName);
+				// if (typeName != null) typeName = typeName.substring(1); // remove #
+				typeValue = "";
+			}
+			else if (localname.equals("form")) {
+				inForm = true;
+				formValue = "";
+			}
 		}
-		else if (localname.equals("form")) {
-			inForm = true;
-			formValue = "";
-		}
 	}
 	
 	@Override
 	public void processCharacters() throws XMLStreamException {
-		if (inW && inAna) typeValue += parser.getText();
-		else if (inW && inForm) formValue += parser.getText();
-		else super.processCharacters();
+		if (elementName != null) {
+			super.processCharacters();
+		}
+		else {
+			if (inW && inAna) typeValue += parser.getText();
+			else if (inW && inForm) formValue += parser.getText();
+			else super.processCharacters();
+		}
 	}
 	
 	@Override
 	public void processEndElement() throws XMLStreamException {
-		if (localname.equals("w")) {
-			inW = false;
+		
+		if (elementName != null) {
+			super.processEndElement();
+		}
+		else {
 			
-			// write W content
-			try {
-				// get the value to test
-				String value = null;
-				if (oldType.equals("word")) {
-					value = formValue;
-				}
-				else {
-					value = anaValues.get(oldType);
-				}
+			if (localname.equals("w")) {
+				inW = false;
 				
-				if (newType.equals("word")) { // update form property
-					updateFormValueIfMatch(value);
-				}
-				else { // update another word property
-					if (value != null) {
-						updateAnaValuesIfMatch(value);
+				// write W content
+				try {
+					// get the value to test
+					String value = null;
+					if (oldType.equals("word")) {
+						value = formValue;
 					}
-				}
-				
-				// write the word element
-				writer.writeStartElement("txm:form");
-				writer.writeCharacters(formValue);
-				writer.writeEndElement();
-				
-				for (String k : anaValues.keySet()) {
-					String resp = anaResps.get(k);
-					if (resp == null) resp = "#txm_recode";
+					else {
+						value = anaValues.get(oldType);
+					}
 					
-					writer.writeStartElement("txm:ana");
-					writer.writeAttribute("resp", resp);
-					writer.writeAttribute("type", k);
-					writer.writeCharacters(anaValues.get(k));
+					if (newType.equals("word")) { // update form property
+						updateFormValueIfMatch(value);
+					}
+					else { // update a ana property
+						if (value != null) {
+							updateAnaValuesIfMatch(value);
+						}
+					}
+					
+					// write the word element
+					writer.writeStartElement("txm:form");
+					writer.writeCharacters(formValue);
 					writer.writeEndElement();
+					
+					for (String k : anaValues.keySet()) {
+						String resp = anaResps.get(k);
+						if (resp == null) resp = "#txm_recode";
+						
+						writer.writeStartElement("txm:ana");
+						writer.writeAttribute("resp", resp);
+						writer.writeAttribute("type", k);
+						writer.writeCharacters(anaValues.get(k));
+						writer.writeEndElement();
+					}
 				}
+				catch (XMLStreamException e) {
+					e.printStackTrace();
+				}
 			}
-			catch (XMLStreamException e) {
-				e.printStackTrace();
+			else if (localname.equals("ana")) {
+				anaValues.put(typeName, typeValue);
+				inAna = false;
 			}
+			else if (localname.equals("form")) {
+				inForm = false;
+			}
+			
+			if (!inW) super.processEndElement(); // don't write W content
 		}
-		else if (localname.equals("ana")) {
-			anaValues.put(typeName, typeValue);
-			inAna = false;
+	}
+	
+	protected String getValueIfMatch(String value) {
+		for (Pattern rule : rules.keySet()) {
+			if (rule.matcher(value).matches()) {
+				return rules.get(rule); // ok stop
+			}
 		}
-		else if (localname.equals("form")) {
-			inForm = false;
-		}
 		
-		if (!inW) super.processEndElement(); // don't write W content
+		return value;
 	}
 	
 	protected void updateFormValueIfMatch(String value) {
-		for (Pattern rule : rules.keySet()) {
-			if (rule.matcher(value).matches()) {
-				formValue = rules.get(rule);
+		
+		if (converter != null) {
+			String v = converter.getValue(parser, localname, null, value);
+			if (v != null) {
+				formValue = v;
 				return; // ok stop
 			}
 		}
+		else {
+			for (Pattern rule : rules.keySet()) {
+				if (rule.matcher(value).matches()) {
+					formValue = rules.get(rule);
+					return; // ok stop
+				}
+			}
+		}
 		
+		
 		noMatchValues.add(value);
 	}
 	
 	protected void updateAnaValuesIfMatch(String value) {
-		for (Pattern rule : rules.keySet()) {
-			if (rule.matcher(value).matches()) {
-				value = rules.get(rule);
-				anaValues.put(newType, value); // do a replace if newType == oldType :-)
+		
+		if (converter != null) {
+			String v = converter.getValue(parser, localname, null, value);
+			if (v != null) {
+				anaValues.put(newType, v); // do a replace if newType == oldType :-)
 				anaResps.put(newType, "#txm_recode");
-				return;
+				return; // ok stop
 			}
 		}
+		else {
+			
+			for (Pattern rule : rules.keySet()) {
+				if (rule.matcher(value).matches()) {
+					value = rules.get(rule);
+					anaValues.put(newType, value); // do a replace if newType == oldType :-)
+					anaResps.put(newType, "#txm_recode");
+					return;
+				}
+			}
+		}
 		if (DELETE.equals(mode)) anaValues.put(newType, ""); // do a replace if newType == oldType :-)
 		else if (ABANDON.equals(mode)) anaValues.put(newType, "ERROR(" + value + ")"); // do a replace if newType == oldType :-)
 		
@@ -174,16 +305,23 @@
 	
 	public static void main(String args[]) {
 		try {
-			File xmlFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test.xml");
-			File tmpFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test-o.xml");
-			String oldType = "type";
-			String newType = "type";
-			LinkedHashMap<Pattern, String> rules = new LinkedHashMap<Pattern, String>();
-			rules.put(Pattern.compile("w"), "WORD");
+			File xmlFile = new File("/home/mdecorde/xml/recode/test.xml");
+			File tmpFile = new File("/home/mdecorde/xml/recode/test-o.xml");
+			String oldType = "myattr";
+			String newType = "myattr";
+			LinkedHashMap<Pattern, String> rules = new LinkedHashMap<>();
+			rules.put(Pattern.compile(".+"), "NEWW");
 			rules.put(Pattern.compile("x.+"), "XWORD");
 			rules.put(Pattern.compile("y"), "YWORD");
 			rules.put(Pattern.compile("y.*"), "YMULTIWORD");
-			XMLTXMFileRuledConversion converter = new XMLTXMFileRuledConversion(xmlFile, rules, oldType, newType, ABANDON);
+			XMLTXMFileRuledConversion converter = new XMLTXMFileRuledConversion(xmlFile, rules, "w", oldType, newType, ABANDON);
+			converter.converter = new Converter() {
+				
+				@Override
+				public String getValue(XMLStreamReader parser, String localname, String attribute, String value) {
+					return "NEW" + value;
+				}
+			};
 			System.out.println(converter.process(tmpFile));
 		}
 		catch (Exception e) {
Index: tmp/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/conversion/CorpusRuledConvertion.java
===================================================================
--- tmp/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/conversion/CorpusRuledConvertion.java	(revision 3054)
+++ tmp/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/conversion/CorpusRuledConvertion.java	(revision 3055)
@@ -17,7 +17,7 @@
 
 public class CorpusRuledConvertion {
 	
-	LinkedHashMap<Pattern, String> rules = new LinkedHashMap<Pattern, String>();
+	LinkedHashMap<Pattern, String> rules = new LinkedHashMap<>();
 	
 	private String oldType;
 	
@@ -75,7 +75,7 @@
 			if (!xmlFile.getName().endsWith(".xml")) continue;
 			
 			File tmpFile = new File(xmlFile.getParentFile(), "tmp_" + xmlFile.getName());
-			XMLTXMFileRuledConversion converter = new XMLTXMFileRuledConversion(xmlFile, rules, oldType, newType, XMLTXMFileRuledConversion.ABANDON);
+			XMLTXMFileRuledConversion converter = new XMLTXMFileRuledConversion(xmlFile, rules, null, oldType, newType, XMLTXMFileRuledConversion.ABANDON);
 			if (converter.process(tmpFile)) {
 				xmlFile.delete();
 				// try {
Index: tmp/org.txm.annotation.kr.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.annotation.kr.core/META-INF/MANIFEST.MF	(revision 3054)
+++ tmp/org.txm.annotation.kr.core/META-INF/MANIFEST.MF	(revision 3055)
@@ -1,12 +1,12 @@
 Manifest-Version: 1.0
 Automatic-Module-Name: org.txm.annotation.kr.core
 Bundle-SymbolicName: org.txm.annotation.kr.core;singleton:=true
-Require-Bundle: org.txm.searchengine.cqp.core;visibility:=reexport,jav
- ax.persistence;bundle-version="2.1.0";visibility:=reexport,org.eclips
- e.persistence.jpa;bundle-version="2.6.0";visibility:=reexport,org.ecl
- ipse.persistence.jpa.jpql;bundle-version="2.6.0";visibility:=reexport
- ,org.txm.annotation.core;visibility:=reexport,org.eclipse.persistence
- .asm;bundle-version="6.0.0"
+Require-Bundle: org.txm.searchengine.cqp.core;visibility:=reexport,
+ javax.persistence;bundle-version="2.1.0";visibility:=reexport,
+ org.eclipse.persistence.jpa;bundle-version="2.6.0";visibility:=reexport,
+ org.eclipse.persistence.jpa.jpql;bundle-version="2.6.0";visibility:=reexport,
+ org.txm.annotation.core;visibility:=reexport,
+ org.eclipse.persistence.asm;bundle-version="6.0.0";visibility:=reexport
 Meta-Persistence: META-INF/persistence.xml
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
Index: tmp/org.txm.annotation.core/src/org/txm/annotation/core/AnnotationEngine.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/core/AnnotationEngine.java	(revision 3054)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/core/AnnotationEngine.java	(revision 3055)
@@ -6,6 +6,8 @@
 
 import org.txm.core.engines.Engine;
 import org.txm.objects.CorpusBuild;
+import org.txm.tokenizer.SimpleStringTokenizer;
+import org.txm.tokenizer.StringTokenizer;
 import org.txm.utils.ConsoleProgressBar;
 import org.txm.utils.DeleteDir;
 
@@ -29,6 +31,15 @@
 	public abstract boolean hasAnnotationsToSave(CorpusBuild corpus);
 	
 	/**
+	 * 
+	 * @return a StringTokenizer, override this method if the engine needs a speciq tokenization
+	 * @throws Exception
+	 */
+	public StringTokenizer getStringTokenizer(String lang) throws Exception {
+		return new SimpleStringTokenizer(lang);
+	}
+	
+	/**
 	 * Automatically annotate a XML-TXM file
 	 * 
 	 * @param xmlFile to annotate
@@ -72,6 +83,7 @@
 		
 		for (File xmlFile : files) {
 			ret = processFile(xmlFile, binaryCorpusDirectory, parameters) && ret;
+			
 			cpb.tick();
 		}
 		cpb.done();
Index: tmp/org.txm.annotation.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.annotation.core/META-INF/MANIFEST.MF	(revision 3054)
+++ tmp/org.txm.annotation.core/META-INF/MANIFEST.MF	(revision 3055)
@@ -1,8 +1,8 @@
 Manifest-Version: 1.0
 Automatic-Module-Name: org.txm.annotation.core
 Bundle-SymbolicName: org.txm.annotation.core;singleton:=true
-Require-Bundle: org.txm.core;bundle-version="0.7.0";visibility:=reexpo
- rt
+Require-Bundle: org.txm.core;bundle-version="0.7.0";visibility:=reexport,
+ org.txm.tokenizer.core
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
 Bundle-RequiredExecutionEnvironment: JavaSE-1.8
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 3054)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 3055)
@@ -1902,8 +1902,12 @@
 	 * Refresh reference column title.
 	 */
 	public void refreshReferenceColumnTitle() {
-		
-		referenceColumn.setText(concordance.getRefViewPattern().getTitle());
+		if (concordance.getRefViewPattern() != null) {
+			referenceColumn.setText(concordance.getRefViewPattern().getTitle());
+		}
+		else {
+			referenceColumn.setText("References");
+		}
 	}
 	
 	/**
Index: tmp/org.txm.core/src/java/org/txm/xml/SimpleHook.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/xml/SimpleHook.java	(revision 3054)
+++ tmp/org.txm.core/src/java/org/txm/xml/SimpleHook.java	(revision 3055)
@@ -12,7 +12,7 @@
  */
 public abstract class SimpleHook<T extends XMLParser> extends Hook<T> {
 	
-	public SimpleHook(String name, HookActivator activator, T parentParser) throws IOException, XMLStreamException {
+	public SimpleHook(String name, HookActivator<T> activator, T parentParser) throws IOException, XMLStreamException {
 		super(name, activator, parentParser);
 	}
 	
Index: tmp/org.txm.core/src/java/org/txm/xml/XMLParser.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/xml/XMLParser.java	(revision 3054)
+++ tmp/org.txm.core/src/java/org/txm/xml/XMLParser.java	(revision 3055)
@@ -53,9 +53,9 @@
 	
 	int processingXInclude = 0;
 	
-	LinkedHashMap<String, Hook> hooks = new LinkedHashMap<>();
+	LinkedHashMap<String, Hook<?>> hooks = new LinkedHashMap<>();
 	
-	private Hook activeHook = null;
+	private Hook<?> activeHook = null;
 	
 	public XMLParser(File infile) throws IOException, XMLStreamException {
 		this(infile.toURI().toURL());
@@ -409,11 +409,11 @@
 	 * 
 	 * @return the actual hooks hash
 	 */
-	public LinkedHashMap<String, Hook> getHooks() {
+	public LinkedHashMap<String, Hook<? extends XMLParser>> getHooks() {
 		return hooks;
 	}
 	
-	public void addHook(String name, Hook hook) {
+	public void addHook(String name, Hook<? extends XMLParser> hook) {
 		hooks.put(name, hook);
 	}
 }
Index: tmp/org.txm.core/src/java/org/txm/xml/XMLProcessor.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/xml/XMLProcessor.java	(revision 3054)
+++ tmp/org.txm.core/src/java/org/txm/xml/XMLProcessor.java	(revision 3055)
@@ -439,12 +439,12 @@
 	 * @return the actual hooks hash
 	 */
 	@Override
-	public LinkedHashMap<String, Hook> getHooks() {
+	public LinkedHashMap<String, Hook<?>> getHooks() {
 		return hooks;
 	}
 	
 	@Override
-	public void addHook(String name, Hook hook) {
+	public void addHook(String name, Hook<?> hook) {
 		hooks.put(name, hook);
 	}
 }
Index: tmp/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 3054)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 3055)
@@ -129,11 +129,10 @@
 				Log.fine("Registering " + enginesManager.getEnginesDescription() + " engines manager...");
 				addEngineManager(enginesManager);
 				if (enginesManager.fetchEngines()) {
-					// System.out.println("add engine: "+engine);
-					
+					Log.fine(NLS.bind("{0} {1} engine(s) loaded.", enginesManager.size(), EngineType.TAL));
 				}
 				else {
-					Log.warning("No engine found for " + enginesManager + ", installation failed.");
+					Log.fine("No engine found for " + enginesManager + ", installation failed.");
 				}
 			}
 			catch (Throwable e) {
Index: tmp/org.txm.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.core/META-INF/MANIFEST.MF	(revision 3054)
+++ tmp/org.txm.core/META-INF/MANIFEST.MF	(revision 3055)
@@ -461,7 +461,8 @@
  org.eclipse.core.resources;visibility:=reexport,
  org.txm.libs.office;bundle-version="0.0.0";visibility:=reexport,
  org.txm.libs.msoffice;bundle-version="0.0.0";visibility:=reexport,
- org.txm.libs.hsqldb;bundle-version="1.0.0";visibility:=reexport
+ org.txm.libs.hsqldb;bundle-version="1.0.0";visibility:=reexport,
+ org.txm.tokenizer.core;bundle-version="1.0.0";visibility:=reexport
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
 Bundle-Activator: org.txm.core.Activator
Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 3054)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 3055)
@@ -951,7 +951,12 @@
 	
 	@Override
 	public String getComputingStartMessage() {
-		return TXMCoreMessages.bind(ConcordanceCoreMessages.concordanceOfP0InTheP1Corpus, this.pQuery.asString(), this.getCorpus().getName());
+		if (this.pQuery == null) {
+			return TXMCoreMessages.bind(ConcordanceCoreMessages.concordanceOfP0InTheP1Corpus, "<none>", this.getCorpus());
+		}
+		else {
+			return TXMCoreMessages.bind(ConcordanceCoreMessages.concordanceOfP0InTheP1Corpus, this.pQuery.asString(), this.getCorpus());
+		}
 	}
 	
 	@Override
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xtz/XTZImporter.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xtz/XTZImporter.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xtz/XTZImporter.groovy	(revision 3055)
@@ -26,6 +26,7 @@
 import org.txm.utils.ConsoleProgressBar
 import org.txm.utils.io.*
 import org.txm.importer.xtz.*
+import org.txm.core.engines.*
 
 class XTZImporter extends Importer {
 	
@@ -381,6 +382,14 @@
 				File infile = f;
 				File outfile = new File(module.getBinaryDirectory(),"tokenized/"+f.getName());
 				SimpleTokenizerXml tokenizer = new SimpleTokenizerXml(infile, outfile, lang)
+				if (module.getProject().getAnnotate()) { // an annotation will be done, does the annotation engine needs another tokenizer ?
+					String engineName = module.getProject().getImportParameters().node("annotate").get("engine", "TreeTagger")
+					def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
+					def stringTokenizer = engine.getStringTokenizer(lang)
+					if (stringTokenizer != null) {
+						tokenizer.setStringTokenizer(stringTokenizer)
+					}
+				}
 				tokenizer.setRetokenize(retokenize)
 				if (outSideTextTagsRegex != null && outSideTextTagsRegex.trim().length() > 0) {
 					tokenizer.setOutSideTextTags(outSideTextTagsRegex)
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xtz/TTAnnotater.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xtz/TTAnnotater.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xtz/TTAnnotater.groovy	(revision 3055)
@@ -28,7 +28,8 @@
 		String corpusname = module.getProject().getName();
 		String lang = module.getProject().getLang();
 
-		def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+		String engineName = module.getProject().getImportParameters().node("annotate").get("engine", "TreeTagger")
+		def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 		if (module.isMultiThread()) {
 			def hash = [:]
 			for (File txmFile : inputDirectory.listFiles()) {
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/hyperprince/hyperprinceLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/hyperprince/hyperprinceLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/hyperprince/hyperprinceLoader.groovy	(revision 3055)
@@ -80,7 +80,8 @@
 //ANNOTATE
 println "-- ANNOTATE - Running NLP tools"
 if (annotate) {
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 	}
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/frantext/frantextLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/frantext/frantextLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/frantext/frantextLoader.groovy	(revision 3055)
@@ -156,7 +156,8 @@
 boolean annotate_status = true;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools - $model model"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotate_status = true;
 		if (project.getCleanAfterBuild()) {
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xml/xmlLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xml/xmlLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/xml/xmlLoader.groovy	(revision 3055)
@@ -237,7 +237,8 @@
 boolean annotationSuccess = false;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true
 		if (project.getCleanAfterBuild()) {
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/bfm/bfmLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/bfm/bfmLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/bfm/bfmLoader.groovy	(revision 3055)
@@ -136,7 +136,8 @@
 boolean annotate_status = true;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools - $model model"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotate_status = true;
 		
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/doc/docLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/doc/docLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/doc/docLoader.groovy	(revision 3055)
@@ -257,7 +257,8 @@
 boolean annotationSuccess = false;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 		if (project.getCleanAfterBuild()) {
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/tmx/tmxLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/tmx/tmxLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/tmx/tmxLoader.groovy	(revision 3055)
@@ -87,7 +87,8 @@
 if (MONITOR != null) MONITOR.worked(20, "ANNOTATE - Running NLP tools");
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	def mapForTreeTagger = [:]
 	for (def k : textLangs.keySet()) mapForTreeTagger[k] = textLangs[k].toLowerCase();
 		println "TreeTagger models to use per text: $mapForTreeTagger"
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/factiva/factivaLoader.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/factiva/factivaLoader.groovy	(revision 3054)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/importer/factiva/factivaLoader.groovy	(revision 3055)
@@ -215,7 +215,8 @@
 boolean annotationSuccess = false;
 if (annotate) {
 	println "-- ANNOTATE - Running NLP tools"
-	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger")
+	String engineName = project.getImportParameters().node("annotate").get("engine", "TreeTagger")
+	def engine = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine(engineName)
 	if (engine.processDirectory(txmDir, binDir, ["lang":model])) {
 		annotationSuccess = true;
 		if (project.getCleanAfterBuild()) {
